searchNodes=[{"doc":"Hemdal is a system for Alert/Alarm very customizable. It's based on Nagios where you have different scripts to check the status of different elements of your system providing back information about these checks. The Hemdal Core is agnostic to the way we can be connected to the external server to perform checks and even, we can implement our own agents in case the access or communication to the servers is difficult or requires customization. Motivation The problem with other systems like Nagios, Icinga or Sensu is they are based on the client/server infrastructure and requires to install an agent inside of each remote node. Hemdal is agnostic about the way of access to the host but it's more inclined to provide the mechanics needed to connect actively without agents. However, it's agnostic, it's meaning that we could implement an agent and access to the server using that agent. Hosts The way to run the checks depends on the host. By default, hemdal_core is only implementing Local which is running locally the commands using the same user as the hemdal core. The available and official hosts are the following ones: Local , included with core. [Trooper](https://github.com/altenwald/hemdal_trooper) uses Trooper to connect via SSH to the remote servers. See Hemdal.Config for further information. Config The configuration is also abstracted using Hemdal.Config . We can use only one provider and this should be configured as follows: # config/config.exs config :hemdal , :config_module , Hemdal.Config.Backend.Env config :hemdal , Hemdal.Config , [ # here the checks configuration ] We have available the following official backends for the configuration: Hemdal.Config.Backend.Env , as shown above, it's putting the whole configuration inside of the configuration file for Elixir. Hemdal.Config.Backend.Json , it's specifying the JSON files to be loaded and they are loaded each time we are requesting data for the alerts. See Hemdal.Config for further information. Event When something is happening with the checks an event is generated. There are different ways to configure the way we receive the events and it's linked to the checks, see Hemdal.Check for further information. The events could be implemented via GenStage . See Hemdal.Event for futher information. Notification One of the event consumers is in charge of triggering notifications. These have a specific format. We have implementation at the moment for the following backends for the notifications: Hemdal.Notifier.Slack is sending the event to a Slack webhook. Hemdal.Notifier.Mattermost is sending the even to a Mattermost webhook. See Hemdal.Notifier for futher information.","ref":"Hemdal.html","title":"Hemdal","type":"module"},{"doc":"Retrieve all the alerts. See Hemdal.Check.get_all/0 for further information.","ref":"Hemdal.html#get_all_alerts/0","title":"Hemdal.get_all_alerts/0","type":"function"},{"doc":"Reload all of the alerts and hosts. See Hemdal.Check.reload_all/0 and Hemdal.Host.reload_all/0 for further information.","ref":"Hemdal.html#reload_all/0","title":"Hemdal.reload_all/0","type":"function"},{"doc":"Start the alert based on the alert ID.","ref":"Hemdal.html#start_alert!/1","title":"Hemdal.start_alert!/1","type":"function"},{"doc":"Every check performed by Hemdal is based on a state machine which is in charge of running a command, check the return and based on the return and if it was successfully executed or not, determine the state of the machine. The state machine has the following states: disabled : it's not performing checks, it waits until it's activated. normal : it's running correctly the command and always receiving a success state. It's configuring a state timeout based on check_in_sec from Hemdal.Config.Alert . failing : when in normal state, it receives an failed response, it's moved to failing status. It's configuring a state timeout based on recheck_in_sec and if it's not recovering after a number of retries it's moving to broken (see Hemdal.Config.Alert ). broken : it was not running correctly for some time. We consider the subject under check broken and we are checking every broken_recheck_in_sec seconds. Only if it's recovered it back to normal state.","ref":"Hemdal.Check.html","title":"Hemdal.Check","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Hemdal.Check.html#child_spec/1","title":"Hemdal.Check.child_spec/1","type":"function"},{"doc":"Check if the alert is running.","ref":"Hemdal.Check.html#exists?/1","title":"Hemdal.Check.exists?/1","type":"function"},{"doc":"Get all of the alerts running. It's requesting to the supervisor the list of all of the alerts and it's gathering the status for each one based on the get_status/1 function.","ref":"Hemdal.Check.html#get_all/0","title":"Hemdal.Check.get_all/0","type":"function"},{"doc":"Returns the PID of the alert process if it's running.","ref":"Hemdal.Check.html#get_pid/1","title":"Hemdal.Check.get_pid/1","type":"function"},{"doc":"Get the status of an alert. It's requesting the status directly to the process.","ref":"Hemdal.Check.html#get_status/1","title":"Hemdal.Check.get_status/1","type":"function"},{"doc":"Reload all of the alerts based on the configuration backend. See Hemdal.Config for further information. If the alert isn't running it's starting it.","ref":"Hemdal.Check.html#reload_all/0","title":"Hemdal.Check.reload_all/0","type":"function"},{"doc":"Ensure all of the alerts are started.","ref":"Hemdal.Check.html#start_all/0","title":"Hemdal.Check.start_all/0","type":"function"},{"doc":"Update the alert passing the new configuration to the process. It's useful when we want to change the configuration for the command, the host or whatever else inside of the alert/check.","ref":"Hemdal.Check.html#update_alert/1","title":"Hemdal.Check.update_alert/1","type":"function"},{"doc":"The alert ID in use to identify the state machine running the checks for the alert.","ref":"Hemdal.Check.html#t:alert_id/0","title":"Hemdal.Check.alert_id/0","type":"type"},{"doc":"The returned status retrieved from the process is built to contain a map with keys which are strings and the content which could be different depending on the key. The keys are the following ones: status is an atom and it could be :ok , :disabled , :warn or :error . alert is a map which is including information for the alert itself, information like: id, name, host, and command. last_update is a naive datetime generated at the moment. result is a map with information of the executed command.","ref":"Hemdal.Check.html#t:returned_status/0","title":"Hemdal.Check.returned_status/0","type":"type"},{"doc":"The status available inside of the events. It's valid for both, current and previous state.","ref":"Hemdal.Check.html#t:status/0","title":"Hemdal.Check.status/0","type":"type"},{"doc":"","ref":"Hemdal.Check.html#t:t/0","title":"Hemdal.Check.t/0","type":"type"},{"doc":"Hemdal needs to load a configuration to get the checks to be processed, how to trigger the alerts and how to connect to the systems to perform the checks. This module define all of the data needed for the configuration and the contract needed to be followed for the libraries which are going to act as backend systems. The backend is configured in the following way: # config/config.exs config :hemdal , config_module : Hemdal.Config.Backend.Env The possible backends and supported officially are: Hemdal.Config.Backend.Env which is configuring via config.exs in the Elixir configuration way. Hemdal.Config.Backend.Json which is using JSON files. Check those modules to get further information about the implementation and usage.","ref":"Hemdal.Config.html","title":"Hemdal.Config","type":"behaviour"},{"doc":"Retrieves the alert giving an alert_id using the configured backend.","ref":"Hemdal.Config.html#get_alert_by_id!/1","title":"Hemdal.Config.get_alert_by_id!/1","type":"function"},{"doc":"Retrieve an alert giving an alert_id .","ref":"Hemdal.Config.html#c:get_alert_by_id!/1","title":"Hemdal.Config.get_alert_by_id!/1","type":"callback"},{"doc":"Retrieve all of the alerts using the configured backend.","ref":"Hemdal.Config.html#get_all_alerts/0","title":"Hemdal.Config.get_all_alerts/0","type":"function"},{"doc":"Get all of the alerts. It should provide a way to retrieve a list with the alerts in the format defined by Hemdal.Config.Alert or an empty list.","ref":"Hemdal.Config.html#c:get_all_alerts/0","title":"Hemdal.Config.get_all_alerts/0","type":"callback"},{"doc":"Retrieve all of the hosts using the configured backend.","ref":"Hemdal.Config.html#get_all_hosts/0","title":"Hemdal.Config.get_all_hosts/0","type":"function"},{"doc":"Retrieve all of the hosts. The implementation of this callback should provide a list of Hemdal.Config.Host or an empty list.","ref":"Hemdal.Config.html#c:get_all_hosts/0","title":"Hemdal.Config.get_all_hosts/0","type":"callback"},{"doc":"Retrieve the host giving a host_id using the configured backend.","ref":"Hemdal.Config.html#get_host_by_id!/1","title":"Hemdal.Config.get_host_by_id!/1","type":"function"},{"doc":"Retrieve the host giving a host_id .","ref":"Hemdal.Config.html#c:get_host_by_id!/1","title":"Hemdal.Config.get_host_by_id!/1","type":"callback"},{"doc":"Alert entity used for the alert configuration. It is including the following configuration params: id the ID for the alert. Used for launching the process, see Hemdal.Check . enabled let us know if the alert is enabled (ok, warn, or error) or disabled (in disabled status). name the name provided to the alert. check_in_sec the interval time (in seconds) to run the check. In ok or normal state. recheck_in_sec the interval time (in seconds) where the command is failing and it should be checked a number of retries in this interval of time previously to move to broken state. broken_recheck_in_sec the interval time (in seconds) where the command is running during the broken state. retries is the number of retries we are running in failing state previously to determine it's broken. command_args is a list of arguments to be in use with the command. host is the Hemdal.Config.Host data. command is a nested structure including the command to be executed, the name of the command, and the command type. See Hemdal.Config.Alert.Command . notifiers is a list of Hemdal.Config.Notifier .","ref":"Hemdal.Config.Alert.html","title":"Hemdal.Config.Alert","type":"module"},{"doc":"Callback implementation for Construct.cast/2 .","ref":"Hemdal.Config.Alert.html#cast/2","title":"Hemdal.Config.Alert.cast/2","type":"function"},{"doc":"Callback implementation for Construct.make!/2 .","ref":"Hemdal.Config.Alert.html#make!/2","title":"Hemdal.Config.Alert.make!/2","type":"function"},{"doc":"Callback implementation for Construct.make/2 .","ref":"Hemdal.Config.Alert.html#make/2","title":"Hemdal.Config.Alert.make/2","type":"function"},{"doc":"","ref":"Hemdal.Config.Alert.html#t:t/0","title":"Hemdal.Config.Alert.t/0","type":"type"},{"doc":"The command structure is defining the command to be executed inside of each alert. The data used is: name the name of the script. type the type of the script could be line or script . The first one let us define a command in a single line and the last one let us define a script, a multi-line code which will be copied and executed in the host. command as the command line to be executed. It could be only one line or a multi-line script.","ref":"Hemdal.Config.Alert.Command.html","title":"Hemdal.Config.Alert.Command","type":"module"},{"doc":"Callback implementation for Construct.cast/2 .","ref":"Hemdal.Config.Alert.Command.html#cast/2","title":"Hemdal.Config.Alert.Command.cast/2","type":"function"},{"doc":"Callback implementation for Construct.make!/2 .","ref":"Hemdal.Config.Alert.Command.html#make!/2","title":"Hemdal.Config.Alert.Command.make!/2","type":"function"},{"doc":"Callback implementation for Construct.make/2 .","ref":"Hemdal.Config.Alert.Command.html#make/2","title":"Hemdal.Config.Alert.Command.make/2","type":"function"},{"doc":"","ref":"Hemdal.Config.Alert.Command.html#t:t/0","title":"Hemdal.Config.Alert.Command.t/0","type":"type"},{"doc":"The host information.","ref":"Hemdal.Config.Host.html","title":"Hemdal.Config.Host","type":"module"},{"doc":"Callback implementation for Construct.cast/2 .","ref":"Hemdal.Config.Host.html#cast/2","title":"Hemdal.Config.Host.cast/2","type":"function"},{"doc":"Callback implementation for Construct.make!/2 .","ref":"Hemdal.Config.Host.html#make!/2","title":"Hemdal.Config.Host.make!/2","type":"function"},{"doc":"Callback implementation for Construct.make/2 .","ref":"Hemdal.Config.Host.html#make/2","title":"Hemdal.Config.Host.make/2","type":"function"},{"doc":"","ref":"Hemdal.Config.Host.html#t:t/0","title":"Hemdal.Config.Host.t/0","type":"type"},{"doc":"Defines the type for module in use for the Hemdal.Config.Notifier and Hemdal.Host implementations to define which modules will be in use for each case.","ref":"Hemdal.Config.Module.html","title":"Hemdal.Config.Module","type":"module"},{"doc":"Module is module() .","ref":"Hemdal.Config.Module.html#t:t/0","title":"Hemdal.Config.Module.t/0","type":"type"},{"doc":"Notifier is in charge of define the amount of notifiers it should be in use for a notification, and the data to perform the notification. The available fields are the following ones: token is the information needed to send a message for some platforms like Slack or Mattermost. But it could means even a password for an email backend. type the name used to be concatenated to Hemdal.Notifier and find for the module. username is the name of the user to show the notification. But it could means different things depending on the backend. For an email backend it could be the user/email to send the message. log_level used to send the notifications. If we specify an error log level it will notify only when a change from/to error is happening. See Hemdal.Event.Notification for further information. metadata the extra data sent to the notifier.","ref":"Hemdal.Config.Notifier.html","title":"Hemdal.Config.Notifier","type":"module"},{"doc":"Callback implementation for Construct.cast/2 .","ref":"Hemdal.Config.Notifier.html#cast/2","title":"Hemdal.Config.Notifier.cast/2","type":"function"},{"doc":"Callback implementation for Construct.make!/2 .","ref":"Hemdal.Config.Notifier.html#make!/2","title":"Hemdal.Config.Notifier.make!/2","type":"function"},{"doc":"Callback implementation for Construct.make/2 .","ref":"Hemdal.Config.Notifier.html#make/2","title":"Hemdal.Config.Notifier.make/2","type":"function"},{"doc":"","ref":"Hemdal.Config.Notifier.html#t:t/0","title":"Hemdal.Config.Notifier.t/0","type":"type"},{"doc":"Define the options ( Keyword ) implementation for Construct . This way we can use the Hemdal.Config.Options everywhere the options entry is needed.","ref":"Hemdal.Config.Options.html","title":"Hemdal.Config.Options","type":"module"},{"doc":"Options is Keyword.t() .","ref":"Hemdal.Config.Options.html#t:t/0","title":"Hemdal.Config.Options.t/0","type":"type"},{"doc":"Configuration backend reader using the environment or Elixir configuration. See Hemdal.Config.Backend for further information. The backend is needing the configuration (see Application or Config ) for specify the configuration as follows: # config/config.exs import Config config :hemdal , Hemdal.Config , [ [ id : &quot;36c16e85-7221-4021-8d6d-89f38a6d136c&quot; , name : &quot;valid alert check&quot; , enabled : true , host : [ id : &quot;ec8fff22-41c2-4245-8a7b-5157d40c33a7&quot; , module : Hemdal.Host.Local , name : &quot;localhost&quot; ] , command : [ name : &quot;get ok status&quot; , type : &quot;line&quot; , command : &quot;echo &#39;[&quot; OK &quot;, &quot; valid one! &quot;]&#39;&quot; ] , check_in_sec : 60 , recheck_in_sec : 1 , broken_recheck_in_sec : 10 , retries : 1 ] ] See Hemdal.Config.Alert and Hemdal.Config.Host for further information.","ref":"Hemdal.Config.Backend.Env.html","title":"Hemdal.Config.Backend.Env","type":"module"},{"doc":"Retrieve the full list of the alerts which appear in the environment configuration.","ref":"Hemdal.Config.Backend.Env.html#get_all_alerts/0","title":"Hemdal.Config.Backend.Env.get_all_alerts/0","type":"function"},{"doc":"Retrieve the full list of the hosts which appear in the environment configuration.","ref":"Hemdal.Config.Backend.Env.html#get_all_hosts/0","title":"Hemdal.Config.Backend.Env.get_all_hosts/0","type":"function"},{"doc":"Configuration backend reader using JSON. See Hemdal.Config.Backend for further information. The backend is needing the configuration (see Application or Config ) to know where the JSON file is located. You can write in the configuration an entry like this: # config/config.exs import Config config :hemdal , Hemdal.Config , hosts_file : &quot;hosts.json&quot; , alerts_file : &quot;alerts.json&quot; The hosts file is intended to configure all of the necessary hosts to be accessible to run the checks and the alerts are the configuration for each check. An example of the hosts file is as follows: [ { &quot;id&quot;: &quot;2a8572d4-ceb3-4200-8b29-dd1f21b50e54&quot;, &quot;name&quot;: &quot;localhost&quot;, &quot;type&quot;: &quot;Local&quot;, &quot;max_workers&quot;: 1 } ] And an example for the alerts file is as follows: [ { &quot;id&quot;: &quot;52d13d6d-f217-4152-965d-cf5f488ceac4&quot;, &quot;name&quot;: &quot;valid alert check&quot;, &quot;host_id&quot;: &quot;2a8572d4-ceb3-4200-8b29-dd1f21b50e54&quot;, &quot;command&quot;: { &quot;name&quot;: &quot;get ok status&quot;, &quot;type&quot;: &quot;line&quot;, &quot;command&quot;: &quot;echo '[&quot;OK&quot;, &quot;valid one!&quot;]'&quot; } } ] If you want to know more about what are the parameters you can use, see Hemdal.Config.Alert and Hemdal.Config.Host for further information.","ref":"Hemdal.Config.Backend.Json.html","title":"Hemdal.Config.Backend.Json","type":"module"},{"doc":"Get all of the alerts. It's reading the alerts file specified in the configuration and the hosts file to create the full information for the alert.","ref":"Hemdal.Config.Backend.Json.html#get_all_alerts/0","title":"Hemdal.Config.Backend.Json.get_all_alerts/0","type":"function"},{"doc":"Get all of the hosts. It's reading the hosts file specified in the configuration and returning it as a list of Hemdal.Config.Host elements.","ref":"Hemdal.Config.Backend.Json.html#get_all_hosts/0","title":"Hemdal.Config.Backend.Json.get_all_hosts/0","type":"function"},{"doc":"Host is spawning processes to run tasks for the corresponding host. It's a way of limiting the amount of commands triggered against a host and ensure the rest of the commands stay in the queue. It's also the base for the implementation of the way of running commands. At the moment the available way to run commands are: Hemdal.Host.Local intended to run local commands. Hemdal.Host.Trooper intended to run SSH commands. It's not included in the main repository, you can find more information here . If you want to know more about what could be included in a command or to be run in a host you can review the following modules: Hemdal.Config.Alert.Command where you can check what's included inside of the command. Hemdal.Config.Host where you can find information about the host. Implement a new Host If you need to implement a new way to run external commands, you can create a new Hemdal.Host.XXX module which will be using the module Hemdal.Host inside. For example, if you need to implement a telnet way to access to the remote hosts, you can implement a module as follows: defmodule Hemdal.Host.Telnet do use Hemdal.Host @impl Hemdal.Host def exec ( host , command ) do # do your stuff { :ok , errorlevel , output } end @impl Hemdal.Host def write_file ( host , filename , content ) do raise &quot;Impossible to transfer files&quot; end @impl Hemdal.Host def delete ( host , filename ) do raise &quot;Impossible to remove files&quot; end end While telnet isn't prepared to transfer files, it's raising an error which is telling the system that's impossible to use the script way for running commands.","ref":"Hemdal.Host.html","title":"Hemdal.Host","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Hemdal.Host.html#child_spec/1","title":"Hemdal.Host.child_spec/1","type":"function"},{"doc":"Remove a file which was created with write_file/3 when the execution of the script was finalised.","ref":"Hemdal.Host.html#c:delete/2","title":"Hemdal.Host.delete/2","type":"callback"},{"doc":"Exec a command using the method implemented by the module where it's implemented. The exec/2 command is getting a handler from the transaction and the command to be executed as a string.","ref":"Hemdal.Host.html#c:exec/2","title":"Hemdal.Host.exec/2","type":"callback"},{"doc":"Run or execute the command passed as parameter. It's needed to pass the host ID to find the process where to send the request, and the the command and the arguments to run the command. It's returning a tuple for :ok or :error and a set of data which depends on if it was success or not. The success return data is usually including the following keys (all of them as strings): status which could be OK , FAIL , WARN or UNKNOWN . message which is a string containing a message to show. The failure return data is usually similar to the previous one but it could be containing something different depending on the return of the remote command. If the JSON sent back from the command is valid, it's usually using that as data and it's marked as UNKNOWN status if there is no status defined.","ref":"Hemdal.Host.html#exec/3","title":"Hemdal.Host.exec/3","type":"function"},{"doc":"Check if the host is started based on the host ID passed as parameter.","ref":"Hemdal.Host.html#exists?/1","title":"Hemdal.Host.exists?/1","type":"function"},{"doc":"Retrieve the PID providing the host ID.","ref":"Hemdal.Host.html#get_pid/1","title":"Hemdal.Host.get_pid/1","type":"function"},{"doc":"Performs a reload for all of the hosts. It's retrieving the configuration for all of the hosts and applying it for each host. It's reloading the configuration for each host and applying it through the update_host/1 function.","ref":"Hemdal.Host.html#reload_all/0","title":"Hemdal.Host.reload_all/0","type":"function"},{"doc":"Start a new host under the Hemdal.Host.Supervisor module.","ref":"Hemdal.Host.html#start/1","title":"Hemdal.Host.start/1","type":"function"},{"doc":"Start all of the hosts based on the configuration. It's retrieving all of the hosts from the configuration and the using each host with the start/1 function.","ref":"Hemdal.Host.html#start_all/0","title":"Hemdal.Host.start_all/0","type":"function"},{"doc":"Start a new host directly. It's intended to be in use from the supervisor, but it could be used for test purposes.","ref":"Hemdal.Host.html#start_link/1","title":"Hemdal.Host.start_link/1","type":"function"},{"doc":"The transaction is an optional callback which is implemented by default if you are using use Hemdal.Host and it's ensuring you can provide to the write_file/3 , exec/2 and delete/2 the same handler which must be provided to the running function. As an example, the default implementation of this callback is as follows: @impl Hemdal.Host def transaction ( host , f ) , do : f . ( host )","ref":"Hemdal.Host.html#c:transaction/2","title":"Hemdal.Host.transaction/2","type":"callback"},{"doc":"Update the host configuration. If the host isn't running it's starting it and passing it the configuration provided as the host parameter. In a nutshell, it's: if exist host ID then perform an update of the host information, else start the process with the host information.","ref":"Hemdal.Host.html#update_host/1","title":"Hemdal.Host.update_host/1","type":"function"},{"doc":"Write a file in the remote (or local) host. It's intended to write the scripts which will be needed to be executed after that with exec/2 .","ref":"Hemdal.Host.html#c:write_file/3","title":"Hemdal.Host.write_file/3","type":"callback"},{"doc":"The command to be executed.","ref":"Hemdal.Host.html#t:command/0","title":"Hemdal.Host.command/0","type":"type"},{"doc":"The command arguments to be passed with the execution command.","ref":"Hemdal.Host.html#t:command_args/0","title":"Hemdal.Host.command_args/0","type":"type"},{"doc":"The errorlevel is shell concept. In the shell every command is returning an integer as the errorlevel after the running, if that's 0 (zero), it's meaning the execution was fine, otherwise a positive or negative number means the running was wrong and the number could means something different depending on the command.","ref":"Hemdal.Host.html#t:errorlevel/0","title":"Hemdal.Host.errorlevel/0","type":"type"},{"doc":"Handler is used by the backend implementation of the host, it could be whatever depending on the needs of the backend implementation. For example, it could be the SSH connection or the credentials, or the way to access to the PTY or TTY. See the implementations for further details.","ref":"Hemdal.Host.html#t:handler/0","title":"Hemdal.Host.handler/0","type":"type"},{"doc":"The console output. It will be decoded using JSON to determine what's the information processed and generated by the command to be processed.","ref":"Hemdal.Host.html#t:output/0","title":"Hemdal.Host.output/0","type":"type"},{"doc":"The reason of the failure. It's usually an atom, but it could be whatever.","ref":"Hemdal.Host.html#t:reason/0","title":"Hemdal.Host.reason/0","type":"type"},{"doc":"","ref":"Hemdal.Host.html#t:t/0","title":"Hemdal.Host.t/0","type":"type"},{"doc":"Implement the host access for the local running commands. It is intended to run commands locally where the system is. It's not recommended when we are going to put the running system inside of a container because it's very limited.","ref":"Hemdal.Host.Local.html","title":"Hemdal.Host.Local","type":"module"},{"doc":"Remove the temporal file.","ref":"Hemdal.Host.Local.html#delete/2","title":"Hemdal.Host.Local.delete/2","type":"function"},{"doc":"Run locally a command. It's using System.shell/2 for achieving that.","ref":"Hemdal.Host.Local.html#exec/2","title":"Hemdal.Host.Local.exec/2","type":"function"},{"doc":"Write a file locally, the file is intended to be located in a temporal location, if the file exists previously it will fail ensuring it's not overloading existent files.","ref":"Hemdal.Host.Local.html#write_file/3","title":"Hemdal.Host.Local.write_file/3","type":"function"},{"doc":"Because of an error in Construct, we need to provide the type t() for each default value if that's a module or an atom different from nil , true , false : https://github.com/ExpressApp/construct/issues/38 Remove this type when the issue is closed and the code is in use by this library.","ref":"Hemdal.Host.Local.html#t:t/0","title":"Hemdal.Host.Local.t/0","type":"type"},{"doc":"Generate events to be consumed. It's the producer for the events.","ref":"Hemdal.Event.html","title":"Hemdal.Event","type":"module"},{"doc":"","ref":"Hemdal.Event.html#notify/1","title":"Hemdal.Event.notify/1","type":"function"},{"doc":"The event is generated usually in Hemdal.Check module and it's based on the structure: alert based on Hemdal.Config.Alert status which is the current status to notify prev_status which is the previous status fail_started when the fail started to happens fail_duration how long the fail is/was last_update when the event was created metadata more information for the event","ref":"Hemdal.Event.html#t:t/0","title":"Hemdal.Event.t/0","type":"type"},{"doc":"Consume each event from Hemdal.Event and process it to generate a log via Logger .","ref":"Hemdal.Event.Log.html","title":"Hemdal.Event.Log","type":"module"},{"doc":"Consume the events generated by the system and send all of these events to the process which run start_link/0 . The even is Hemdal.Event.t() .","ref":"Hemdal.Event.Mock.html","title":"Hemdal.Event.Mock","type":"module"},{"doc":"It is starting a consumer, linked to the caller process, and sending all of the events to the caller process.","ref":"Hemdal.Event.Mock.html#start_link/0","title":"Hemdal.Event.Mock.start_link/0","type":"function"},{"doc":"Stop the consumer, while it's linked to the caller process it's a good idea to stop it.","ref":"Hemdal.Event.Mock.html#stop/1","title":"Hemdal.Event.Mock.stop/1","type":"function"},{"doc":"Consume events from Hemdal.Event to generate the notifications via Hemdal.Notifier . It's based on the configuration from the Hemdal.Config.Notifier module and based on the configuration for the log_level and the level of the event, it could be reported or not. The log levels could be: debug it's reporting everything to the notifier. warn notifies if the previous status is different from the new one. error notifies only if the change is from/to error status.","ref":"Hemdal.Event.Notification.html","title":"Hemdal.Event.Notification","type":"module"},{"doc":"","ref":"Hemdal.Event.Notification.html#process_event/2","title":"Hemdal.Event.Notification.process_event/2","type":"function"},{"doc":"Notifier implements the base for a notification system which will send the event or information message to an external service like Slack, Mattermost, Mailgun, Sendblue, or whatever else provider. The notifier implementation must define the send/3 callback ensuring the sending of the information is being able. The official notifiers supported and implemented by Hemdal are: Hemdal.Notifier.Slack which implements the sending of the Slack message avoiding implement the optional callbacks. Hemdal.Notifier.Mattermost which implements the sending of the Mattermost message and in the same way avoid implement the optional callbacks because are compatible with Slack. Hemdal.Notifier.Mock is an implementation which makes easier the implementation of tests. Implement a new Notifier The requirements are not too many, you only need to create a module in your project with the name Hemdal.Notifier.XXX changing the XXX with the name you want to implement. For example, if you have a specific system via TCP created to notify in your installation, if you give to that system the name of mercury , you can create a module in the implementation of the alert system called Hemdal.Notifier.Mercury and then: defmodule Hemdal.Notifier.Mercury do use Hemdal.Notifier @impl Hemdal.Notifier def send ( message , token , metadata ) do # do your stuff end end The return of send/3 isn't going to be in use, you can return whatever.","ref":"Hemdal.Notifier.html","title":"Hemdal.Notifier","type":"behaviour"},{"doc":"The attach callback which should return the map according to the information attached. The attachment is usually created with the accumulation of the fields inside.","ref":"Hemdal.Notifier.html#c:attach/3","title":"Hemdal.Notifier.attach/3","type":"callback"},{"doc":"Same as attach/3 but let specify the img_url field for adding a custom image to the message.","ref":"Hemdal.Notifier.html#c:attach/4","title":"Hemdal.Notifier.attach/4","type":"callback"},{"doc":"Creates a field representation in a map. See field/0 type for further information. It provides a field name and value which will be included inside of the field map returned. The return format finally will be determined by the implementation.","ref":"Hemdal.Notifier.html#c:field/2","title":"Hemdal.Notifier.field/2","type":"callback"},{"doc":"Creates a field representation in a map. See field/0 type for further information. In addition to the field name and value it's receiving if the field is short or not. It's put in this way to place two fields in the same line (horizontally) if both are short.","ref":"Hemdal.Notifier.html#c:field/3","title":"Hemdal.Notifier.field/3","type":"callback"},{"doc":"Callback for send/3 . It must implement the necessary backend to send the message for the backend implementation. The information passed is the message formatted as a map, see message/0 type for further information. The token must be the information needed for the system to be authenticated or recognised to send the message. Finally, the metadata must be information to be used as extra information inside of the map to be useful for the backend. See metadata/0 type for further information.","ref":"Hemdal.Notifier.html#c:send/3","title":"Hemdal.Notifier.send/3","type":"callback"},{"doc":"Send the message using the notifier module, the status of the event, the previous status, the alert information (see Hemdal.Config.Alert ), metadata and duration from the previous status to the current one. The first parameter is the notifier data, see Hemdal.Config.Notifier for further information. The status could be an atom: :ok for the success state :warn when it's starting to fail :error for the failure state :disabled when the alert is disabled The previous state could be nil if there is no previous state. The metadata is a map which could contains the following keys as strings: &quot;message&quot; for a description of the error, default: &quot;&lt;no description&gt;&quot; &quot;status&quot; for the notification of the Incoming Status or the status which is provided from the alert. The duration could be nil if there is no previous state or if from the previous state was not expected to have a counting of the duration.","ref":"Hemdal.Notifier.html#send/6","title":"Hemdal.Notifier.send/6","type":"function"},{"doc":"The color provided for the attachment. The color is provided usually in the format #rrggbb where we are providing a value from 00-ff for each color to create the RGB (red, green, and blue) combination.","ref":"Hemdal.Notifier.html#t:attach_color/0","title":"Hemdal.Notifier.attach_color/0","type":"type"},{"doc":"The list of the fields attached.","ref":"Hemdal.Notifier.html#t:attach_fields/0","title":"Hemdal.Notifier.attach_fields/0","type":"type"},{"doc":"The name of the attachment.","ref":"Hemdal.Notifier.html#t:attach_name/0","title":"Hemdal.Notifier.attach_name/0","type":"type"},{"doc":"The duration from previous status to the new one.","ref":"Hemdal.Notifier.html#t:duration/0","title":"Hemdal.Notifier.duration/0","type":"type"},{"doc":"The field map representation of the field. It will be dependent of the notifier backend which should determine what's the format desired for the field.","ref":"Hemdal.Notifier.html#t:field/0","title":"Hemdal.Notifier.field/0","type":"type"},{"doc":"The field name is the name of the field which we provide from the sending of the message. We have defined the name of the fields and they are: Host Name, based on the alert host name Command Name, based on the alert command name Description, description from metadata if any Status, the new state Prev. Status, the previous state Duration, the duration from previous to current state Incoming Status, the received status from the check","ref":"Hemdal.Notifier.html#t:field_name/0","title":"Hemdal.Notifier.field_name/0","type":"type"},{"doc":"The field value is the content which should be shown as the value. It must be a string because finally all of the data will be represented as text.","ref":"Hemdal.Notifier.html#t:field_value/0","title":"Hemdal.Notifier.field_value/0","type":"type"},{"doc":"The URL for a custom image to be included inside of the attachment.","ref":"Hemdal.Notifier.html#t:img_url/0","title":"Hemdal.Notifier.img_url/0","type":"type"},{"doc":"The message is a data map where we can define different keys. The information (defined in send/6 ) is as follows: text the text message to be sent username provided by the notifier data, default: &quot;Hemdal&quot; icon_emoji provided by the notifier metadata information, default: &quot;:rotating_light:&quot; channel provided by the notifier metadata, default: &quot;#alerts&quot; attachments is a list of attachments provided by the attach/3 callback implemented in the notifier.","ref":"Hemdal.Notifier.html#t:message/0","title":"Hemdal.Notifier.message/0","type":"type"},{"doc":"The metadata is provided by the notifier structure, see Hemdal.Config.Notifier for further information.","ref":"Hemdal.Notifier.html#t:metadata/0","title":"Hemdal.Notifier.metadata/0","type":"type"},{"doc":"Is it a short field? It is determined mainly for Slack, Mattermost, and similar systems where we can include short fields in the way they could appear two fields in the same line if both are short.","ref":"Hemdal.Notifier.html#t:short?/0","title":"Hemdal.Notifier.short?/0","type":"type"},{"doc":"The possible status processed by the messages.","ref":"Hemdal.Notifier.html#t:status/0","title":"Hemdal.Notifier.status/0","type":"type"},{"doc":"The token is provided from the notifier structure, see Hemdal.Config.Notifier for further information.","ref":"Hemdal.Notifier.html#t:token/0","title":"Hemdal.Notifier.token/0","type":"type"},{"doc":"Performs the notification from Hemdal.Notifier using Mattermost. It's using the webhook capability of Slack to send the message to a specific channel. You can see further information in this link: https://developers.mattermost.com/integrate/webhooks/incoming/","ref":"Hemdal.Notifier.Mattermost.html","title":"Hemdal.Notifier.Mattermost","type":"module"},{"doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete! ( &quot;/users&quot; ) delete! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; ) delete! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#delete!/3","title":"Hemdal.Notifier.Mattermost.delete!/3","type":"function"},{"doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete ( &quot;/users&quot; ) delete ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; ) delete ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#delete/3","title":"Hemdal.Notifier.Mattermost.delete/3","type":"function"},{"doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get! ( &quot;/users&quot; ) get! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; ) get! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#get!/3","title":"Hemdal.Notifier.Mattermost.get!/3","type":"function"},{"doc":"Perform a GET request. See request/1 or request/2 for options definition. get ( &quot;/users&quot; ) get ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; ) get ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#get/3","title":"Hemdal.Notifier.Mattermost.get/3","type":"function"},{"doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head! ( &quot;/users&quot; ) head! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; ) head! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#head!/3","title":"Hemdal.Notifier.Mattermost.head!/3","type":"function"},{"doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head ( &quot;/users&quot; ) head ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; ) head ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#head/3","title":"Hemdal.Notifier.Mattermost.head/3","type":"function"},{"doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options! ( &quot;/users&quot; ) options! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; ) options! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#options!/3","title":"Hemdal.Notifier.Mattermost.options!/3","type":"function"},{"doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options ( &quot;/users&quot; ) options ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; ) options ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#options/3","title":"Hemdal.Notifier.Mattermost.options/3","type":"function"},{"doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Mattermost.html#patch!/4","title":"Hemdal.Notifier.Mattermost.patch!/4","type":"function"},{"doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Mattermost.html#patch/4","title":"Hemdal.Notifier.Mattermost.patch/4","type":"function"},{"doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Mattermost.html#post!/4","title":"Hemdal.Notifier.Mattermost.post!/4","type":"function"},{"doc":"Perform a POST request. See request/1 or request/2 for options definition. post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Mattermost.html#post/4","title":"Hemdal.Notifier.Mattermost.post/4","type":"function"},{"doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Mattermost.html#put!/4","title":"Hemdal.Notifier.Mattermost.put!/4","type":"function"},{"doc":"Perform a PUT request. See request/1 or request/2 for options definition. put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Mattermost.html#put/4","title":"Hemdal.Notifier.Mattermost.put/4","type":"function"},{"doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options.","ref":"Hemdal.Notifier.Mattermost.html#request!/2","title":"Hemdal.Notifier.Mattermost.request!/2","type":"function"},{"doc":"Perform a request. Options :method - the request method, one of [ :head , :get , :delete , :trace , :options , :post , :put , :patch ] :url - either full url e.g. &quot; http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples ExampleApi . request ( method : :get , url : &quot;/users/path&quot; ) # use shortcut methods ExampleApi . get ( &quot;/users/1&quot; ) ExampleApi . post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#request/2","title":"Hemdal.Notifier.Mattermost.request/2","type":"function"},{"doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace! ( &quot;/users&quot; ) trace! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; ) trace! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#trace!/3","title":"Hemdal.Notifier.Mattermost.trace!/3","type":"function"},{"doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace ( &quot;/users&quot; ) trace ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; ) trace ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Mattermost.html#trace/3","title":"Hemdal.Notifier.Mattermost.trace/3","type":"function"},{"doc":"Options that may be passed to a request function. See request/2 for detailed descriptions.","ref":"Hemdal.Notifier.Mattermost.html#t:option/0","title":"Hemdal.Notifier.Mattermost.option/0","type":"type"},{"doc":"Let us perform tests using a notifier which we can control. It's working injecting inside of the metadata the PID of the process where the notification should be triggered. Inside of the configuration we have to inject the notifier with the corresponding information, it's important to choose a backend which let us use the PID as data. If you see Hemdal.CheckTest you can find a way about how to do this.","ref":"Hemdal.Notifier.Mock.html","title":"Hemdal.Notifier.Mock","type":"module"},{"doc":"Performs the notification from Hemdal.Notifier using Slack. It's using the webhook capability of Slack to send the message to a specific channel. You can see further information in this link: https://api.slack.com/messaging/webhooks","ref":"Hemdal.Notifier.Slack.html","title":"Hemdal.Notifier.Slack","type":"module"},{"doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete! ( &quot;/users&quot; ) delete! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; ) delete! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#delete!/3","title":"Hemdal.Notifier.Slack.delete!/3","type":"function"},{"doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete ( &quot;/users&quot; ) delete ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; ) delete ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) delete ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#delete/3","title":"Hemdal.Notifier.Slack.delete/3","type":"function"},{"doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get! ( &quot;/users&quot; ) get! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; ) get! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#get!/3","title":"Hemdal.Notifier.Slack.get!/3","type":"function"},{"doc":"Perform a GET request. See request/1 or request/2 for options definition. get ( &quot;/users&quot; ) get ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; ) get ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) get ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#get/3","title":"Hemdal.Notifier.Slack.get/3","type":"function"},{"doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head! ( &quot;/users&quot; ) head! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; ) head! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#head!/3","title":"Hemdal.Notifier.Slack.head!/3","type":"function"},{"doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head ( &quot;/users&quot; ) head ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; ) head ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) head ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#head/3","title":"Hemdal.Notifier.Slack.head/3","type":"function"},{"doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options! ( &quot;/users&quot; ) options! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; ) options! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#options!/3","title":"Hemdal.Notifier.Slack.options!/3","type":"function"},{"doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options ( &quot;/users&quot; ) options ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; ) options ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) options ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#options/3","title":"Hemdal.Notifier.Slack.options/3","type":"function"},{"doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Slack.html#patch!/4","title":"Hemdal.Notifier.Slack.patch!/4","type":"function"},{"doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) patch ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Slack.html#patch/4","title":"Hemdal.Notifier.Slack.patch/4","type":"function"},{"doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Slack.html#post!/4","title":"Hemdal.Notifier.Slack.post!/4","type":"function"},{"doc":"Perform a POST request. See request/1 or request/2 for options definition. post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Slack.html#post/4","title":"Hemdal.Notifier.Slack.post/4","type":"function"},{"doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put! ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Slack.html#put!/4","title":"Hemdal.Notifier.Slack.put!/4","type":"function"},{"doc":"Perform a PUT request. See request/1 or request/2 for options definition. put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } ) put ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } , query : [ scope : &quot;admin&quot; ] )","ref":"Hemdal.Notifier.Slack.html#put/4","title":"Hemdal.Notifier.Slack.put/4","type":"function"},{"doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options.","ref":"Hemdal.Notifier.Slack.html#request!/2","title":"Hemdal.Notifier.Slack.request!/2","type":"function"},{"doc":"Perform a request. Options :method - the request method, one of [ :head , :get , :delete , :trace , :options , :post , :put , :patch ] :url - either full url e.g. &quot; http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples ExampleApi . request ( method : :get , url : &quot;/users/path&quot; ) # use shortcut methods ExampleApi . get ( &quot;/users/1&quot; ) ExampleApi . post ( client , &quot;/users&quot; , %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#request/2","title":"Hemdal.Notifier.Slack.request/2","type":"function"},{"doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace! ( &quot;/users&quot; ) trace! ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; ) trace! ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace! ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#trace!/3","title":"Hemdal.Notifier.Slack.trace!/3","type":"function"},{"doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace ( &quot;/users&quot; ) trace ( &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; ) trace ( client , &quot;/users&quot; , query : [ scope : &quot;admin&quot; ] ) trace ( client , &quot;/users&quot; , body : %{ name : &quot;Jon&quot; } )","ref":"Hemdal.Notifier.Slack.html#trace/3","title":"Hemdal.Notifier.Slack.trace/3","type":"function"},{"doc":"Options that may be passed to a request function. See request/2 for detailed descriptions.","ref":"Hemdal.Notifier.Slack.html#t:option/0","title":"Hemdal.Notifier.Slack.option/0","type":"type"},{"doc":"Because of an error in Construct, we need to provide the type t() for each default value if that's a module or an atom different from nil , true , false : https://github.com/ExpressApp/construct/issues/38 Remove this type when the issue is closed and the code is in use by this library.","ref":"Hemdal.Notifier.Slack.html#t:t/0","title":"Hemdal.Notifier.Slack.t/0","type":"type"},{"doc":"Hemdal is a library designed to run commands and retrieve a result. It let us implement the different aspects of the system as we want and it's extensible enough to provide us ways of implementing extensions without modify the core code base. Hemdal isn't a stand-alone system, if you need that kind of service, check Hemdal UI which implements Hemdal User Interface with Phoenix Framework and Trooper for providing more features and a stand-alone way to run Hemdal.","ref":"getting_started.html","title":"Getting started","type":"extras"},{"doc":"You need to understand the elements of Hemdal to know how to use it and extend it. The layers are: Hemdal.Host is the way Hemdal connect with the hosts to run commands. It's an implementation of a pool of hosts defined by the maximum number of tasks which could be running at the same time on the same host. Hemdal.Check is the state of each alarm/alert of the system. It's a state machine which is running in a defined interval of time a command against a host. Depending on the result it's generating information and changing its states. Hemdal.Event is the event generator, each time the state machine ( Hemdal.Check ) generates an event, it goes to this module and it's send to all of its consumers. It's based on GenStage and you can create as many consumers as you need. Hemdal.Notifier is a specific consumer for Hemdal.Event which have the mission to report the events to specific endpoints. You can implement new modules to provide new ways of notification. These are the basic ways we can provide for extend the system.","ref":"getting_started.html#understanding-the-layers","title":"Getting started - Understanding the layers","type":"extras"},{"doc":"At the moment, to connect to different hosts, we provide only one way, but because SSH is a bit more complicated, we created a new repository to show you how to extend Hemdal in a non-intrusive way to implement your own stuff: Hemdal.Host.Local is running commands using System.shell/2 , it's not too fancy but it's useful. Hemdal.Host.Trooper is a way to implement SSH to connect to remote hosts. See Hemdal.Config.Host to know how to configure and use them.","ref":"getting_started.html#hosts","title":"Getting started - Hosts","type":"extras"},{"doc":"While there are different examples which you can see in the source code, it's easier to think about the events as a simple GenStage consumer. You can write your own, put under your own supervisor and consume from Hemdal.Event . You will receive always the %Hemdal.Event{} structure. We have the implementation of the following event consumers: Hemdal.Event.Log which is triggering a log for each event received. Hemdal.Event.Notification which is converting the event into a notification for notifier. Hemdal.Event.Mock which is in use for test purposes.","ref":"getting_started.html#events","title":"Getting started - Events","type":"extras"},{"doc":"The notifiers are defined in the alert configuration (see Hemdal.Config.Alert ). You can specify a list of notifiers to be in use every time a new event is triggering a notification. We have defined the following notifiers: Hemdal.Notifier.Slack which is triggering a message for Slack system. Hemdal.Notifier.Mattermost which is triggering a message for Mattermost system. Hemdal.Notifier.Mock which is for testing purposes.","ref":"getting_started.html#notifiers","title":"Getting started - Notifiers","type":"extras"},{"doc":"","ref":"creating_alerts.html","title":"Creating_Alerts","type":"extras"},{"doc":"","ref":"notifying_to_slack.html","title":"Notifying_to_Slack","type":"extras"}]